import unittest
import inspect

from wnodes.cli.commands import auth_openstack

class AuthOpenStackTestCase(unittest.TestCase):

    user_data = {
        'user': {
            'user_proxy':'/home/ronchieri/ronchieri.proxy',
            'ca_path':'/etc/grid-security/certificates'},
        'egi-cloud.zam.kfa-juelich.de': {
            'auth_host': 'egi-cloud.zam.kfa-juelich.de',
            'auth_path': '/home/ronchieri',
            'auth_port':5000}
        }

    provider = 'egi-cloud.zam.kfa-juelich.de'

    def test_perform_a_transfer(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            auth = auth_openstack.AuthOpenStack(AuthOpenStackTestCase.user_data)
            auth.perform_a_transfer(AuthOpenStackTestCase.provider)
            msg = 'Failed Transfer'
            self.assert_('id' in auth.get_token().keys(), \
                '%s, %s - FAILED, %s' %
                (path, method, msg))

            token = auth_openstack.Token(AuthOpenStackTestCase.user_data[AuthOpenStackTestCase.provider]['auth_path'],
                AuthOpenStackTestCase.provider)
            token.store_token(auth.get_token())
            id=token.get_id()
            self.assert_(id == auth.get_token()['id'], \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
        except AssertionError, err:
            print err
        except auth_openstack.TokenExpired,err:
            print err
        except auth_openstack.AuthOpenStackError, err:
            print err

def main():
    suite = unittest.TestLoader().loadTestsFromTestCase(AuthOpenStackTestCase)
    unittest.TextTestRunner(verbosity=2).run(suite)

if __name__ == '__main__':
    main()
