import sys
import os
import exceptions

class FormatError(exceptions.Exception):
    pass

class Format:

    metadata_structure = {'TITLE': ['title', 't'],
        'OS': 'os',
        'OS-VERSION': 'os-version',
        'OS-ARCH': 'os-arch',
        'IDENTIFIER': ['identifier', 'i'],
        'ENDORSER': ['endorser', 'e'],
        'DESCRIPTION': ['description', 'd'],
        'PLATFORM': ['platform', 'p'],
        'PUBLISHER': 'publisher'}

    names = ['tag', 't',
        'os',
        'os-version',
        'os-arch',
        'identifier', 'i',
        'endorser', 'e',
        'description', 'd',
        'platform', 'p',
        'publisher']

    def __init__(self, fields):
        self.names = self.__check_metadata_structure(fields.replace(" ","").split(','))

    def __check_metadata_structure(self, fields):
        valid_structure = []
        for value in fields:
            if value not in Format.names:
                raise FormatError('Fields in the format are not correct')
            else:
                for key, val in Format.metadata_structure.iteritems():
                    if type(val) == list:
                        for el in val:
                            if value == el:
                                valid_structure.append((key, value))
                    elif value == val: 
                        valid_structure.append((key, value))
                if len(valid_structure) == 0:
                    raise FormatError('Fields in the format are not correct')
        return valid_structure

    def get_names(self):
        return self.names
