__author__ = 'Elisabetta Ronchieri'

import sys
import os
import exceptions

from wnodes.cli.utils import utilities 

class FileNotFound(exceptions.Exception):
    pass

def get_file_name(file_name):
    found = False
    new_file = ''
    for dir in sys.path:
        new_file = os.path.join(dir,file_name)
        if os.path.isfile(new_file):
            found = True
            break
    return found, new_file 

def get_images_information(file_name = 'size-images-info.json'):
    '''Get size images information of providers'''
    found, valid_file_name = get_file_name('wnodes/cli/providers/'+file_name)
    if found:
        tp_info = utilities.get_json_data(valid_file_name)
    else:
        raise FileNotFound('Please check component installation')

    return tp_info
