import sys
import os
import exceptions

class SequenceError(exceptions.Exception):
    pass

class Sequence:
    def __init__(self, value):
        if ' ' in value:
            raise SequenceError('The sequence contains empty space')
        self.sequence = []
        if ';' in value:
            whole_sequence = self.__get_sequence(value, c=';')
        elif '\n' in value:
            whole_sequence = self.__get_sequence(value, c='\n')
        elif ',' in value:
            whole_sequence = [value]
        else:
            whole_sequence = [value]
        for y in whole_sequence:
            self.sequence.append(self.__get_sequence(y, c=','))

    def __get_sequence(self, val, c=','):
        return [x.strip() for x in val.split(c)]

    def get_sequence(self):
        return self.sequence
