import unittest
import inspect
from wnodes.cli.utils import checks

class ChecksTestCase(unittest.TestCase):
    cmd = 'curl'
    valid_cmd = 'curl'
    wrong_cmd = '/bin/curl'

    def test_is_cmd_bin(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            state = checks.is_bin(ChecksTestCase.cmd)
            msg = 'Cmd %s does not exist' % ChecksTestCase.cmd
            self.assert_(not state, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))            
        except AssertionError, err:
            print err

    def test_is_cmd_valid(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            state, cmd = checks.is_cmd_valid(ChecksTestCase.valid_cmd)
            msg = 'Cmd %s is not valid' % ChecksTestCase.valid_cmd
            self.assert_(state, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
            state, cmd = checks.is_cmd_valid(ChecksTestCase.wrong_cmd)
            msg = 'Cmd %s is not valid' % ChecksTestCase.wrong_cmd
            self.assert_(state, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
        except AssertionError, err:
            print err

    def test_get_cmd_name(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            name = checks.get_cmd_name(ChecksTestCase.valid_cmd)
            name = checks.get_cmd_name(ChecksTestCase.wrong_cmd)
        except checks.NoCmdFound, err:
            print err

def main():
    suite = unittest.TestLoader().loadTestsFromTestCase(ChecksTestCase)
    unittest.TextTestRunner(verbosity=2).run(suite)

if __name__ == '__main__':
    main()
