import unittest
import inspect
from wnodes.cli.utils import load_config

class LoadConfigTestCase(unittest.TestCase):
    def test_get_parser(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            lc = load_config.LoadConfig(config_file='load-data.ini')
            lc.get_parser()
        except load_config.WrongConfigurationFile, err:
            print err

    def test_get_data(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            lc = load_config.LoadConfig(config_file='load-data.ini')
            lc.get_data()
        except load_config.WrongConfigurationFile, err:
            print err

    def test_wrong_file(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            lc = load_config.LoadConfig(config_file='load_data.ini')
            lc.get_data() 
        except load_config.WrongConfigurationFile, err:
            print err

def main():
    suite = unittest.TestLoader().loadTestsFromTestCase(LoadConfigTestCase)
    unittest.TextTestRunner(verbosity=2).run(suite)

if __name__ == '__main__':
    main()
