import unittest
import inspect
from wnodes.cli.utils import location

class LocationFormatTestCase(unittest.TestCase):
    data = {'server':{'endpoint':'test-wnodes-web01.cnaf.infn.it',
        'port':8443}}
    location = 'https://%s:%s/compute/f36d6438-d960-40eb-bcb0-853dac3e878h'\
        % (data['server']['endpoint'],str(data['server']['port']))
    wrong_uid = 'https://%s:%s/compute/f36d6438-d960-40eb-bcb0'\
        % (data['server']['endpoint'],str(data['server']['port']))
    wrong_url = 'f36d6438-d960-40eb-bcb0-853dac3e878h'

    def test_location(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            location.LocationFormat(LocationFormatTestCase.data,
                LocationFormatTestCase.location)
        except location.LocationFormatError, err:
            print err

    def test_location_with_wrong_uid(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            location.LocationFormat(LocationFormatTestCase.data,
                LocationFormatTestCase.wrong_uid)
        except location.LocationFormatError, err:
            print err

    def test_location_with_wrong_url(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            location.LocationFormat(LocationFormatTestCase.data,
                LocationFormatTestCase.wrong_url)
        except location.LocationFormatError, err:
            print err

def main():
    suite = unittest.TestLoader().loadTestsFromTestCase(LocationFormatTestCase)
    unittest.TextTestRunner(verbosity=2).run(suite)

if __name__ == '__main__':
    main()
