import unittest
import inspect
from wnodes.cli.utils import sequence

class SequenceTestCase(unittest.TestCase):
    wrong_value = ' '
    simple_sequence = ['a;b;c;d', 'a ;b ;c;d']
    complex_sequence = 'a,b,c;a;e,f,g'

    def test_simple_sequence(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            seq = sequence.Sequence(SequenceTestCase.simple_sequence[0])
            val = seq.get_sequence()
            msg = 'seq %s is wrong' % val
            self.assert_(len(val) == 4, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
        except AssertionError, err:
            print err
        except sequence.SequenceError, err:
            print err

    def test_simple_strange_sequence(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            seq = sequence.Sequence(SequenceTestCase.simple_sequence[1])
            val = seq.get_sequence()
            msg = 'seq %s is wrong' % val
            self.assert_(len(val) == 4, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
        except AssertionError, err:
            print err
        except sequence.SequenceError, err:
            print err

    def test_wrong_value(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            seq = sequence.Sequence(SequenceTestCase.wrong_value)
            val = seq.get_sequence()
            msg = 'seq %s is wrong' % val
            self.assert_(len(val) == 3, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
        except AssertionError, err:
            print err
        except sequence.SequenceError, err:
            print err

    def test_complex_sequence(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            seq = sequence.Sequence(SequenceTestCase.complex_sequence)
            val = seq.get_sequence()
            msg = 'seq %s is wrong' % val
            self.assert_(len(val) == 3, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
        except AssertionError, err:
            print err
        except sequence.SequenceError, err:
            print err

def main():
    suite = unittest.TestLoader().loadTestsFromTestCase(SequenceTestCase)
    unittest.TextTestRunner(verbosity=2).run(suite)

if __name__ == '__main__':
    main()
