import unittest
import inspect
from wnodes.cli.utils import utilities

class UtilitiesTestCase(unittest.TestCase):
    long_strings = ['string1', 'string10']

    def test_get_longest_string(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            n,el = utilities.get_longest_string(UtilitiesTestCase.long_strings)
            msg = 'The longest string %s is wrong' % el
            self.assert_(len(UtilitiesTestCase.long_strings[1]) == n, \
                '%s, %s - FAILED, %s' %
                (path, method, msg))
        except AssertionError, err:
            print err

    def test_add_empty_space(self):
        stack_value = inspect.stack()[0]
        path = stack_value[1]
        method = stack_value[3]

        try:
            n, el = utilities.get_longest_string(UtilitiesTestCase.long_strings)
            for tmp_el in UtilitiesTestCase.long_strings:
                empty_el = utilities.add_empty_space(len(tmp_el), n)
                msg = 'The added empty space %s is wrong' % len(empty_el)
                self.assert_(len(empty_el) >= 4, \
                    '%s, %s - FAILED, %s' %
                    (path, method, msg))
        except AssertionError, err:
            print err

def main():
    suite = unittest.TestLoader().loadTestsFromTestCase(UtilitiesTestCase)
    unittest.TextTestRunner(verbosity=2).run(suite)

if __name__ == '__main__':
    main()
